#!/usr/bin/perl

use strict;
use CGI();

require "inc/cwcal.pl";

my $title2 = __("Configuration Wcal");
my $title = __("Fichier de configuration");

my $q = new CGI();

cw_header($title);

print "<center>\n";
print "<h1><a href=\".\">$title2</a></h1>\n";
print "</center>\n";

print "<form method=post>\n";

print "<h2>$title</h2>";
if ($q->param("edit"))
{
    print '<input type="submit" name="cancel" value="'.__("Annuler").'">'."\n";
}
else
{
    print '<input type="submit" name="edit" value="'.__("Editer").'">'."\n";;
}
print "<hr>\n";

my $wcald = cw_get_wcald();
open(CONF, $wcald->{CONF_FILE}) or die "Can't open $wcald->{CONF_FILE} for reading: $!";
my $line;
my $key;
my $val;
my $access = 0;
if ($q->param("edit"))
{
    print '<textarea name="content" rows=30 cols=80>'."\n";
    while ($line = <CONF>)
    {
	print $line;
    }
    print "</textarea>\n";
    print "<hr>\n";
    print '<input type="submit" name="modify" value="'.__("Valider").'">'."\n";
    print '<input type="reset" value="'.__("Rinitialiser").'">'."\n";
}
else
{
    if ($q->param("content") && !$q->param("cancel"))
    {
	my $str = $q->param("content");
	$str =~ s/\r//mg;
	close(CONF);
	open(CONF, ">/tmp/wcal.conf") or die "Can't open /tmp/wcal.conf for writing: $!";
	print CONF $str;
	close(CONF);
	system("\\cp /tmp/wcal.conf $wcald->{CONF_FILE}");
	chmod(0640, $wcald->{CONF_FILE});
	print '<font color="00aa00" size=4>'.__("Fichier de configuration modifi")."</font>\n";
	open(CONF, $wcald->{CONF_FILE}) or die "Can't open $wcald->{CONF_FILE} for reading: $!";
    }
    print "<pre>\n";
    while ($line = <CONF>)
    {
	if ($access)
	{
	    if ($line =~ s/^(\s*)(end\s+access\s+file)/$1<font color=\"\#bb00bb\"><i>$2<\/i><\/font>/) { $access = 0; }
	    else 
	    {
		chomp($line);
		$line = '<font color="#bb00ff">'.$line."</font>\n";
	    }
	}
	elsif ($line =~ s/^(\s*)(access\s+file)/$1<font color=\"\#bb00bb\"><b>$2<\/b><\/font>/) { $access = 1; }
	elsif ($line =~ s/^(\s*)(user)(\s*=\s*)(.*\S)/$1<font color=\"\#bb8800\"><b>$2<\/b><\/font>$3<a href=\"user.cgi?id=$4\"><font color=\"\#bb8800\"><b>$4<\/b><\/font><\/a>/) {}
	elsif ($line =~ s/^(\s*)(end\s+user)/$1<font color=\"\#bb8800\"><i>$2<\/i><\/font>/) {}
	elsif ($line =~ s/^(\s*)(group)(\s*=\s*)(.*\S)/$1<font color=\"\#aa0000\"><b>$2<\/b><\/font>$3<a href=\"group.cgi?id=$4\"><font color=\"\#aa0000\"><b>$4<\/b><\/font><\/a>/) {}
	elsif ($line =~ s/^(\s*)(end\s+group)/$1<font color=\"\#aa0000\"><i>$2<\/i><\/font>/) {}
	elsif ($line =~ s/^(\s*)([^=]+\S)(\s*=)/$1<b>$2<\/b>$3/) {}
	elsif ($line =~ s/^(\s*)(\#[^\#]*\S)$/$1<font color=\"\#ff0000\"><i>$2<\/i><\/font>/) {}
	
	print $line;
    }
    print "</pre>\n";
    print "<hr>\n";
}
close(CONF);

print "</form>\n";

cw_footer();
